<?php

	require_once(TOOLKIT . '/class.datasource.php');
	
	class datasourcealphabetical_pagination extends Datasource {
	
		protected $_source;		
		public $alphabet = array(
			'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'
		);
		public $_handleSectionID;
		public $_handleField;
		
		public $dsParamROOTELEMENT = 'alphabetical-pagination';	
		
		public function __construct(&$parent, $env=NULL, $process_params=true) {
			parent::__construct($parent, $env, $process_params);
			
			$this->_dependencies = array();
			
			$this->_handleSectionID = Symphony::Configuration()->get('section', 'alphabetical-pagination');
			$this->_handleField = Symphony::Configuration()->get('field', 'alphabetical-pagination');
		}

		public function about() {
			return array(
					 'name' => 'Alphabetical Pagination',
					 'author' => array(
							'name' => 'm-r Tarakanoff',
							'website' => '',
							'email' => ''),
					 'version' => '1.0',
					 'release-date' => '2011-11-13');	
		}
		
		public function grab(&$param_pool) {
			$result = new XMLElement($this->dsParamROOTELEMENT);	
			
			$fieldID = Symphony::Database()->fetchVar('id', 0, sprintf("
					SELECT `id`
					FROM `tbl_fields`
					WHERE `element_name` = '%s' AND `parent_section` = '%s'
					LIMIT 1
				", $this->_handleField, $this->_handleSectionID));
				
			if(!isset($fieldID)) {
				$result->setValue(__(sprintf('Field handle (%s) of section (%s) not found!', $this->_handleField, $this->_handleSectionID)));
				return $result;
			}
			
			$sql = 'SELECT SUBSTRING(`t1`.value, 1, 1) as letter
				FROM `sym_entries` AS `e`
				LEFT JOIN `sym_entries_data_' . $fieldID . '` AS t1 ON (e.id = t1.entry_id)
				WHERE 1 AND `e`.`section_id` = \'' . $this->_handleSectionID . '\'
				GROUP BY SUBSTRING(t1.value, 1, 1)';
				
			$entries = $this->_Parent->Database->fetch($sql);
			
			$url_parameter = Symphony::Configuration()->get('url-parameter', 'alphabetical-pagination');
			
			if(!isset($url_parameter))
				$url_parameter = '';
			
			$current_letter = $this->_env['param'][$url_parameter]; 
			
			$find_letters = array();
			
			foreach($entries as $entry) {
				$find_letters[] = $entry['letter'];
			}
			
			foreach($this->alphabet as $letter) {
				$xEntry = new XMLElement('entry');
				$xEntry->setValue($letter);
				
				if(!strcasecmp($letter, $current_letter)) {
					$xEntry->setAttribute('select', true);
				}

				if(array_search($letter, $find_letters) === false) {
					$xEntry->setAttribute('empty', true);
				}
				
				$result->appendChild($xEntry);
			}
			
			return $result;
		}
	}

?>