<?php

	require_once(TOOLKIT . '/class.sectionmanager.php');
	
	class extension_alphabetical_pagination extends Extension {

		public function about(){
			return array('name' => 'Alphabetical Pagination',
						 'version' => '1.0',
						 'release-date' => '2011-11-13',
						 'author' => array('name' => 'm-r Tarakanoff',
										   'website' => '',
										   'email' => '')
				 		);
		}

		function __construct($args) {
			parent::__construct($args);
		}

		public function uninstall() {	
			Symphony::Configuration()->remove('alphabetical-pagination');			
			$this->_Parent->saveConfig();
		}

		public function install() {
		}

		public function getSubscribedDelegates() {
			return array(
				array(
					'page' => '/system/preferences/',
					'delegate' => 'AddCustomPreferenceFieldsets',
					'callback' => 'appendPreferences'
				),
			);
		}
		
		public function appendPreferences($context) {
			$sectionManager = new SectionManager($context['parent']);
		    $sections = $sectionManager->fetch(NULL, 'ASC', 'name');
			
			$group = new XMLElement('fieldset');
			$group->setAttribute('class', 'settings');

			$group->appendChild(new XMLElement('legend', 'Alphabetical Pagination'));
						
			$label = Widget::Label(__('Section'));
			
			$options = array();

			foreach($sections as $s) {
				$options[] = array($s->get('id'), (Symphony::Configuration()->get('section', 'alphabetical-pagination') == $s->get('id')), $s->get('name'));
			}

			$label->appendChild(Widget::Select('settings[alphabetical-pagination][section]', $options));
					
			$group->appendChild($label);
			$group->appendChild(new XMLElement('p', 'Section that provides the data for pagination', array('class' => 'help')));
			
			$label = Widget::Label(__('Field'));	
			$label->appendChild(Widget::Input('settings[alphabetical-pagination][field]', Symphony::Configuration()->get('field', 'alphabetical-pagination')));
			$group->appendChild($label);
			$group->appendChild(new XMLElement('p', 'Handle of the field section. The data in this field should be a text value.', array('class' => 'help')));
			
			$label = Widget::Label(__('URL Parameter'));	
						
			$label->appendChild(Widget::Input('settings[alphabetical-pagination][url-parameter]', Symphony::Configuration()->get('url-parameter', 'alphabetical-pagination')));
			$group->appendChild($label);
			$group->appendChild(new XMLElement('p', 'Parameter for the letters in the query string', array('class' => 'help')));

			$context['wrapper']->appendChild($group);
		}
	}

?>